unit dbs_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ADODB, DBCtrls, ExtCtrls, XPMan, StdCtrls, XIComponents, XIInterfaces;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    tblSchemes: TADOTable;
    tblRecords: TADOTable;
    Panel1: TPanel;
    rgSchemes: TRadioGroup;
    XPManifest1: TXPManifest;
    xiPanel: TxiInterfacePanel;
    tblRecordsHASACCESS_INT: TIntegerField;
    tblRecordsID_RECORD: TAutoIncField;
    tblRecordsFIRSTNAME: TWideStringField;
    tblRecordsLASTNAME: TWideStringField;
    tblRecordsAGE: TIntegerField;
    tblRecordsHASACCESS: TBooleanField;
    tblRecordsUSERTYPE: TIntegerField;
    tblRecordsDATEJOINED: TDateTimeField;
    lblModified: TLabel;
    btnApply: TButton;
    DBNavigator: TDBNavigator;
    dsrcRecords: TDataSource;
    btnCancel: TButton;
    procedure FormCreate(Sender: TObject);
    procedure rgSchemesClick(Sender: TObject);
    procedure tblRecordsCalcFields(DataSet: TDataSet);
    procedure xiPanelModify(Sender: TObject);
    procedure tblRecordsHASACCESS_INTChange(Sender: TField);
    procedure btnApplyClick(Sender: TObject);
    procedure tblRecordsAfterScroll(DataSet: TDataSet);
    procedure btnCancelClick(Sender: TObject);
    procedure tblRecordsBeforeScroll(DataSet: TDataSet);
    procedure tblRecordsAfterInsert(DataSet: TDataSet);
    procedure tblRecordsBeforeDelete(DataSet: TDataSet);
    procedure tblRecordsAfterDelete(DataSet: TDataSet);
  private
    { Private declarations }
    f_Data: IXIStorage;
    procedure ApplyData;
    procedure LoadScheme(aNumber: Integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses
 XIDBStorage,
 XIControls,
 XIJvControls;

{$R *.dfm}

procedure TForm1.ApplyData;
begin
 if not (tblRecords.State in [dsEdit, dsInsert]) then
  if tblRecords.RecordCount > 0 then
   tblRecords.Edit
  else
   tblRecords.Insert;
 xiPanel.WriteData(f_Data);
 tblRecords.Post;
end;

procedure TForm1.LoadScheme(aNumber: Integer);
begin
 if xiPanel.IsModified then
  ApplyData;
 tblSchemes.RecNo := aNumber;
 xiPanel.XISource := tblSchemes.Fields[2].AsString;
 xiPanel.Construct(f_Data);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 ADOConnection1.Connected := True;
 tblSchemes.Active := True;
 tblRecords.Active := True;
 f_Data := TxiDBStorage.Make(tblRecords);
 LoadScheme(1);
end;

procedure TForm1.rgSchemesClick(Sender: TObject);
begin
 LoadScheme(rgSchemes.ItemIndex+1);
end;

procedure TForm1.tblRecordsCalcFields(DataSet: TDataSet);
begin
 if tblRecords.State in [dsEdit, dsInsert] then
  Exit;
 if tblRecords.FieldByName('HASACCESS').AsBoolean then
  tblRecords.FieldByName('HASACCESS_INT').AsInteger := 1
 else
  tblRecords.FieldByName('HASACCESS_INT').AsInteger := 0;
end;

procedure TForm1.xiPanelModify(Sender: TObject);
begin
 if xiPanel.IsModified then
  lblModified.Caption := 'Modified'
 else
  lblModified.Caption := '';
 btnApply.Enabled := xiPanel.IsModified;
 btnCancel.Enabled := xiPanel.IsModified;
end;

procedure TForm1.tblRecordsHASACCESS_INTChange(Sender: TField);
begin
 tblRecords.FieldByName('HASACCESS').AsBoolean := tblRecords.FieldByName('HASACCESS_INT').AsInteger = 1;
end;

procedure TForm1.btnApplyClick(Sender: TObject);
begin
 ApplyData;
end;

procedure TForm1.tblRecordsAfterScroll(DataSet: TDataSet);
begin
 if tblRecords.RecordCount = 0 then
  Exit;
 xiPanel.ReadData(f_Data);
end;

procedure TForm1.btnCancelClick(Sender: TObject);
begin
 xiPanel.ReadData(f_Data);
end;

procedure TForm1.tblRecordsBeforeScroll(DataSet: TDataSet);
begin
 if tblRecords.RecordCount = 0 then
  Exit;
 if xiPanel.IsModified then
  ApplyData;
end;

procedure TForm1.tblRecordsAfterInsert(DataSet: TDataSet);
begin
 if tblRecords.RecordCount > 0 then
  xiPanel.ReadData(f_Data);
end;

procedure TForm1.tblRecordsBeforeDelete(DataSet: TDataSet);
begin
 if MessageDlg('Are you sure to delete this record?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
  Abort;
end;

procedure TForm1.tblRecordsAfterDelete(DataSet: TDataSet);
begin
 xiPanel.ReadData(f_Data);
end;

end.
