unit exp_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, XPMan, ExtCtrls, StdCtrls, XIComponents, XIControls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    InterfacePanel: TxiInterfacePanel;
    btnAddEdit: TButton;
    btnAddMemo: TButton;
    btnAddRadioGroup: TButton;
    Bevel1: TBevel;
    btnClear: TButton;
    XPManifest1: TXPManifest;
    btnNewColumn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnAddEditClick(Sender: TObject);
    procedure btnAddMemoClick(Sender: TObject);
    procedure btnAddRadioGroupClick(Sender: TObject);
    procedure btnNewColumnClick(Sender: TObject);
  private
    f_Column: Integer;
    { Private declarations }
    f_Controls: string;
    f_ControlCount: Integer;
    f_InitialHeight: Integer;
    f_InitialWidth: Integer;
    procedure UpdateInterfacePanel;
    procedure ClearInterface;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses
 XIInterfaces,
 XIStorage;

{$R *.dfm}

procedure TForm1.ClearInterface;
begin
 f_Controls := '<columns><groupbox caption="Column 1">';
 f_Column := 1;
 f_ControlCount := 0;
 Width := f_InitialWidth;
 Height := f_InitialHeight;
 UpdateInterfacePanel;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Randomize;
 f_InitialWidth := Width;
 f_InitialHeight := Height;
 ClearInterface;
end;

procedure TForm1.UpdateInterfacePanel;
var
 l_XML: string;
 l_Data: IxiStorage;
begin
 l_XML := '<?xml version="1.0" encoding="ISO-8859-1"?> <root dpix="96" dpiy="96">' + f_Controls +
    '</groupbox></columns></root>';
 l_Data := TxiMemoryStorage.Make; // temporal data storage to transfer data into new interface
 InterfacePanel.WriteData(l_Data);
 InterfacePanel.XISource := l_XML;
 InterfacePanel.Construct(l_Data);
end;

procedure TForm1.btnClearClick(Sender: TObject);
begin
 ClearInterface;
end;

procedure TForm1.btnAddEditClick(Sender: TObject);
begin
 Inc(f_ControlCount);
 f_Controls := f_Controls + '<edit name="edit'+IntToStr(f_ControlCount)+'" caption="Edit control"/>';
 UpdateInterfacePanel;
end;

procedure TForm1.btnAddMemoClick(Sender: TObject);
begin
 Inc(f_ControlCount);
 f_Controls := f_Controls + '<memo name="memo'+IntToStr(f_ControlCount)+'" caption="Memo control"/>';
 UpdateInterfacePanel;
end;

procedure TForm1.btnAddRadioGroupClick(Sender: TObject);
var
 N: Integer;
 I: Integer;
begin
 Inc(f_ControlCount);
 f_Controls := f_Controls + '<radiogroup name="radiogroup'+IntToStr(f_ControlCount)+'" caption="Radiogroup control">';
 N := Random(3)+2;
 for I := 1 to N do
  f_Controls := f_Controls + '<item caption="Item'+IntToStr(I)+'"/>';
 f_Controls := f_Controls + '</radiogroup>'; 
 UpdateInterfacePanel;
end;

procedure TForm1.btnNewColumnClick(Sender: TObject);
begin
 inc(f_Column);
 f_Controls := f_Controls+'</groupbox><groupbox caption="Column '+IntToStr(f_Column)+'">';
 UpdateInterfacePanel;
end;

end.
